Statslog = LibStub("AceAddon-3.0"):NewAddon("Statslog", "AceEvent-3.0",  "AceConsole-3.0")

function Statslog:OnInitialize()
	self.db = LibStub('AceDB-3.0'):New('StatslogDB', self:CreateDefaults(), true)
	AceConfig = LibStub("AceConfigDialog-3.0")
	LibStub("AceConfig-3.0"):RegisterOptionsTable("Statslog", self:CreateOptions())
	AceConfig:AddToBlizOptions("Statslog", "Statslog")
	Statslog:RegisterChatCommand('printstats', 'PrintDefStats')
end

function Statslog:OnEnable()

	if LoggingChat() then
		Statslog:Print("Chat is already being logged.")
	else
		LoggingChat(1);
		Statslog:Print("Chat logging is now enabled.")
	end
	
end

function Statslog:OnDisable()
end

function Statslog:PrintDefStats()
	local _, playerClass = UnitClass("player")
	local playerLevel = UnitLevel("player")
	local _, strength, _, _ = UnitStat("player", 1)
	local _, agility, _, _ = UnitStat("player", 2)
	local dodge_pdr = GetDodgeChance()
	local parry_pdr = GetParryChance()
	local drating = GetCombatRating(CR_DODGE)
	local dratingBonus = GetCombatRatingBonus(CR_DODGE)
	local prating = GetCombatRating(CR_PARRY)
	local pratingBonus = GetCombatRatingBonus(CR_PARRY)
	local mastery = GetCombatRating(CR_MASTERY)
	local masteryTotal = GetMasteryEffect()
	local block_pdr = GetBlockChance()
	local pvppower = GetCombatRating(CR_PVP_POWER)
	local pvppowerBonus = GetCombatRatingBonus(CR_PVP_POWER)

	-- STR AGI post_dodge post_parry  dodge_rating pre_dodge parry_rating pre_parry mastery_rating post_mastery post_block pvppower_rating pvppower
	local logstring = self.db.profile.tag .. " " .. strength .. " " .. agility
	logstring = logstring .. " " .. dodge_pdr .. " " .. parry_pdr
	logstring = logstring .. " " .. drating .. " " .. dratingBonus
	logstring = logstring .. " " .. prating .. " " .. pratingBonus
	logstring = logstring .. " " .. mastery .. " " .. masteryTotal
	logstring = logstring .. " " .. block_pdr
	logstring = logstring .. " " .. pvppower .. " " .. pvppowerBonus
	logstring = logstring .. " " .. playerClass .. " " .. playerLevel

	local id, name = GetChannelName(self.db.profile.channel)
	if (id > 0 and name ~= nil) then
		SendChatMessage(logstring ,"CHANNEL" ,nil ,self.db.profile.channel)
	else
		Statslog:Print("Channel not found, select a correct channel ID.")
	end
end